/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * SelectKanjiFieldsPanel.java
 *
 * Created on 14-abr-2011, 14:42:22
 */
package net.ajaest.lib.swing.panel;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableRowSorter;

import net.ajaest.lib.swing.util.FixedTableModel;
import net.ajaest.lib.swing.util.MoveRowTableModel;

/**
 *
 * @author ajaest10
 */
public class SelectPanel extends javax.swing.JPanel {

	private static final long serialVersionUID = 4303074877333154239L;

	private MoveRowTableModel selectedTableModel;
    private DefaultTableModel notSelectedTableModel;

    /** Creates new form SelectKanjiFieldsPanel */
    public SelectPanel(String leftColumnName, String rigthColumnName, Set<String> selectionElements) {

        List<String> columNames = new ArrayList<String>();

        columNames.add(leftColumnName);
        selectedTableModel = new MoveRowTableModel(columNames);
        selectedTableModel.setCellEditable(false);

		notSelectedTableModel = new FixedTableModel(new String[]{rigthColumnName}, 0);

        for (String s : selectionElements) 
            notSelectedTableModel.addRow(new String[]{s});

        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        _SelectedFieldsPanel = new javax.swing.JPanel();
        _SelectedFieldsScrollPane = new javax.swing.JScrollPane();
        _SelectedFieldsTable = new javax.swing.JTable();
        _NotSelectedFieldsPanel = new javax.swing.JPanel();
        _NoSelectedFieldsScrollPanel = new javax.swing.JScrollPane();
        _NotSelectedFieldsTable = new javax.swing.JTable();
        _AddFieldButton = new javax.swing.JButton();
        _RemoveFieldButton = new javax.swing.JButton();
        ImageIcon topIcon = new ImageIcon(this.getClass().getResource("/images/go-top.png"));
        _GoTopButton = new javax.swing.JButton();
        ImageIcon upIcon = new ImageIcon(this.getClass().getResource("/images/go-up.png"));
        _GoUpButton = new javax.swing.JButton();
        ImageIcon downIcon = new ImageIcon(this.getClass().getResource("/images/go-down.png"));
        _GoDownButton = new javax.swing.JButton();
        ImageIcon bottomIcon = new ImageIcon(this.getClass().getResource("/images/go-bottom.png"));
        _GoBottomButton = new javax.swing.JButton();

        _SelectedFieldsPanel.setBackground(java.awt.Color.white);
        _SelectedFieldsPanel.setPreferredSize(new java.awt.Dimension(0, 0));

        _SelectedFieldsTable.setModel(selectedTableModel);
        _SelectedFieldsScrollPane.setViewportView(_SelectedFieldsTable);

        javax.swing.GroupLayout _SelectedFieldsPanelLayout = new javax.swing.GroupLayout(_SelectedFieldsPanel);
        _SelectedFieldsPanel.setLayout(_SelectedFieldsPanelLayout);
        _SelectedFieldsPanelLayout.setHorizontalGroup(
            _SelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 187, Short.MAX_VALUE)
            .addGroup(_SelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(_SelectedFieldsPanelLayout.createSequentialGroup()
                    .addGap(0, 0, 0)
                    .addComponent(_SelectedFieldsScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 187, Short.MAX_VALUE)
                    .addGap(0, 0, 0)))
        );
        _SelectedFieldsPanelLayout.setVerticalGroup(
            _SelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 250, Short.MAX_VALUE)
            .addGroup(_SelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(_SelectedFieldsScrollPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE))
        );

        _NotSelectedFieldsPanel.setBackground(java.awt.Color.white);
        _NotSelectedFieldsPanel.setPreferredSize(new java.awt.Dimension(0, 0));

        _NotSelectedFieldsTable.setModel(notSelectedTableModel);
        _NotSelectedFieldsTable.setRowSorter(new TableRowSorter<DefaultTableModel>(notSelectedTableModel));
        _NoSelectedFieldsScrollPanel.setViewportView(_NotSelectedFieldsTable);

        javax.swing.GroupLayout _NotSelectedFieldsPanelLayout = new javax.swing.GroupLayout(_NotSelectedFieldsPanel);
        _NotSelectedFieldsPanel.setLayout(_NotSelectedFieldsPanelLayout);
        _NotSelectedFieldsPanelLayout.setHorizontalGroup(
            _NotSelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 187, Short.MAX_VALUE)
            .addGroup(_NotSelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(_NoSelectedFieldsScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 187, Short.MAX_VALUE))
        );
        _NotSelectedFieldsPanelLayout.setVerticalGroup(
            _NotSelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 250, Short.MAX_VALUE)
            .addGroup(_NotSelectedFieldsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addComponent(_NoSelectedFieldsScrollPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE))
        );

        _AddFieldButton.setText("<<");
        _AddFieldButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _AddFieldButtonActionPerformed(evt);
            }
        });

        _RemoveFieldButton.setText(">>");
        _RemoveFieldButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _RemoveFieldButtonActionPerformed(evt);
            }
        });

        _GoTopButton.setIcon(topIcon);
        _GoTopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _GoTopButtonActionPerformed(evt);
            }
        });

        _GoUpButton.setIcon(upIcon);
        _GoUpButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _GoUpButtonActionPerformed(evt);
            }
        });

        _GoDownButton.setIcon(downIcon);
        _GoDownButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _GoDownButtonActionPerformed(evt);
            }
        });

        _GoBottomButton.setIcon(bottomIcon);
        _GoBottomButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                _GoBottomButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(_SelectedFieldsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 187, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_GoBottomButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(_GoUpButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(_GoTopButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(_GoDownButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(_AddFieldButton, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(_RemoveFieldButton, javax.swing.GroupLayout.DEFAULT_SIZE, 86, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(_NotSelectedFieldsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 187, Short.MAX_VALUE)
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {_AddFieldButton, _RemoveFieldButton});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(_NotSelectedFieldsPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
                    .addComponent(_SelectedFieldsPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(_AddFieldButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_RemoveFieldButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(_GoTopButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_GoUpButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(_GoDownButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(_GoBottomButton, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {_AddFieldButton, _RemoveFieldButton});

    }// </editor-fold>//GEN-END:initComponents

    private void _GoDownButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__GoDownButtonActionPerformed

        int[] selRows = _SelectedFieldsTable.getSelectedRows();
        if (selRows.length != 0) {
            selRows = selectedTableModel.moveDown(selRows);
            if (selRows.length > 0) {
                _SelectedFieldsTable.getSelectionModel().setSelectionInterval(selRows[0], selRows[selRows.length - 1]);
            }
        }
    }//GEN-LAST:event__GoDownButtonActionPerformed

    private void _GoBottomButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__GoBottomButtonActionPerformed
        int[] selRows = _SelectedFieldsTable.getSelectedRows();
        if (selRows.length != 0) {
            selRows = selectedTableModel.moveRowsToBottom(selRows);
            if (selRows.length > 0) {
                _SelectedFieldsTable.getSelectionModel().setSelectionInterval(selRows[0], selRows[selRows.length - 1]);
            }
        }
    }//GEN-LAST:event__GoBottomButtonActionPerformed

    private void _GoUpButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__GoUpButtonActionPerformed
        int[] selRows = _SelectedFieldsTable.getSelectedRows();
        if (selRows.length != 0) {
            selRows = selectedTableModel.moveUp(selRows);
            if (selRows.length > 0) {
                _SelectedFieldsTable.getSelectionModel().setSelectionInterval(selRows[0], selRows[selRows.length - 1]);
            }
        }
    }//GEN-LAST:event__GoUpButtonActionPerformed

    private void _GoTopButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__GoTopButtonActionPerformed
        int[] selRows = _SelectedFieldsTable.getSelectedRows();
        if (selRows.length != 0) {
            selRows = selectedTableModel.moveRowsToTop(selRows);
            if (selRows.length > 0) {
                _SelectedFieldsTable.getSelectionModel().setSelectionInterval(selRows[0], selRows[selRows.length - 1]);
            }
        }
    }//GEN-LAST:event__GoTopButtonActionPerformed

    private void _RemoveFieldButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__RemoveFieldButtonActionPerformed
        int[] selRows = _SelectedFieldsTable.getSelectedRows();
        List<Object> selected = new ArrayList<Object>();
        for (int i = selRows.length - 1; i >= 0; i--) {
            selected.add(selectedTableModel.getValueAt(selRows[i], 0));
        }
        for (int i = selected.size() - 1; i >= 0; i--) {
            selectedTableModel.removeRow(selRows[i]);
			notSelectedTableModel.addRow(new Vector<Object>(selected.subList(i, i + 1)));
        }
    }//GEN-LAST:event__RemoveFieldButtonActionPerformed

    private void _AddFieldButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event__AddFieldButtonActionPerformed
        int[] selRows = _NotSelectedFieldsTable.getSelectedRows();
        List<Object> selected = new ArrayList<Object>();
        for (int i = selRows.length - 1; i >= 0; i--) {
            selected.add(notSelectedTableModel.getValueAt(selRows[i], 0));
        }
        for (int i = selected.size() - 1; i >= 0; i--) {
            notSelectedTableModel.removeRow(selRows[i]);
            selectedTableModel.addRow(selected.subList(i, i + 1));
        }
    }//GEN-LAST:event__AddFieldButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton _AddFieldButton;
    private javax.swing.JButton _GoBottomButton;
    private javax.swing.JButton _GoDownButton;
    private javax.swing.JButton _GoTopButton;
    private javax.swing.JButton _GoUpButton;
    private javax.swing.JScrollPane _NoSelectedFieldsScrollPanel;
    private javax.swing.JPanel _NotSelectedFieldsPanel;
    private javax.swing.JTable _NotSelectedFieldsTable;
    private javax.swing.JButton _RemoveFieldButton;
    private javax.swing.JPanel _SelectedFieldsPanel;
    private javax.swing.JScrollPane _SelectedFieldsScrollPane;
    private javax.swing.JTable _SelectedFieldsTable;
    // End of variables declaration//GEN-END:variables

	@SuppressWarnings("unchecked")
	public List<String> getSelectedFields() {

		return (List<String>) selectedTableModel.getColumn(0);
	}

    public static void main(String... args) {
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(SelectPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            Logger.getLogger(SelectPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(SelectPanel.class.getName()).log(Level.SEVERE, null, ex);
        } catch (UnsupportedLookAndFeelException ex) {
            Logger.getLogger(SelectPanel.class.getName()).log(Level.SEVERE, null, ex);
        }
        JFrame jf = new JFrame("Pruebaaaaa");
                
        Set<String> ss = new HashSet<String>();
        
        for(Integer i=1; i<101;i++ )
            ss.add(i.toString());

        jf.add(new SelectPanel("Seleccionado", "No seleccionado",ss));
        jf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        jf.setSize(600, 400);

        jf.setVisible(true);
    }
}
