//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.lib.swing.util.action;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.JList;

//TODO: JavaDoc
public class JListCopyTextAction extends AbstractAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1492781303638882554L;

	private JList jcb;
	private String delimiter;


	public JListCopyTextAction(JList jcb, String delimiter) {
		this.jcb = jcb;

		if (delimiter != null && !delimiter.equals(""))
			this.delimiter = delimiter;
		else
			delimiter = "\r\n";

	}

	@Override
	public void actionPerformed(ActionEvent e) {

		StringBuilder copied = new StringBuilder();

		for (Object val : jcb.getSelectedValues()) {
			copied.append(val.toString());
			copied.append(delimiter);
		}

		String copiedStr = copied.toString();

		if (!copiedStr.equals("")) {
			StringSelection copiedSel = new StringSelection(copied.toString());
			Clipboard cp = Toolkit.getDefaultToolkit().getSystemClipboard();
			cp.setContents(copiedSel, copiedSel);
		}
	}

}
